<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'tr',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fiberler',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'Dil Başvuru Kılavuzu',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'İstisnaları Genişletmek',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => '&Uuml;rete&ccedil;ler',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'tr',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fiberler</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Fiberlere giriş</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Fiberler, tamamen yığıtlanabilen ve yürütmeyi kesintiye uğratılabilen
   işlevlerdir. Fiberin çağrı yığıtının herhangi bir yerinde askıya alınmasıyla
   yürütmenin bekletilmesi ve daha sonra fiberin yürütmeyi kaldığı yerden devam
   ettirmesi sağlanabilir.
  </p>
  <p class="para">
   Fiberler icra yığıtınını tamamını bekletebilir, böylece işlevin davranışını
   değiştirmek için işlevin doğrudan çağrılması gerekmez.
  </p>
  <p class="para">
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> çağrısı ile çağrı yığıtının
   herhangi bir yerinde yürütme kesintiye uğratılabilir (yani,
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> oldukça iç içe çağrıların
   derinlerinde yer alabileceği gibi hiçbir yerde de var olmayabilir).
  </p>
  <p class="para">
   Yığıtsız üreteçlerin (<span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>) tersine, her
   <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> sınıfının kendi çağrı yığıtı vardır. Böylece,
   oldukça iç içe işlev çağrılarında bile bekletme sağlanabilmektedir. Bir
   kesinti noktası belirten bir işlev (yani,
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> çağrısı),
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> dönüş türünün değiştirilmemesini
   gerektirir (bir <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span> örneğinden dönen <a href="language.generators.syntax.php#control-structures.yield" class="link">yield</a>
   deyimini kullanan bir işlevin tersine).
  </p>
  <p class="para">
   Fiberler PHP VM içinden çağrılanlar dahil, <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span>
   işlevine sağlanan işlevler veya <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span> nesnesi
   üzerinde <a href="control-structures.foreach.php" class="link">foreach</a> ile çağrılan yöntemler gibi, herhangi bir işlev çağrısını
   askıya alabilir.
  </p>
  <p class="para">
   Bir kere askıya alınınca, <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span> işlevi
   herhangi bir değerle çağrılarak veya <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>
   kullanarak fiber içinde bir istisna yavrulatarak, fiber yürütmesi kaldığı
   yerden devam ettirilebilir. Değer, <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   yönteminden veya yavrulanan istisnadan döndürülür.
  </p>
  <blockquote class="note"><p><strong class="note">Bilginize</strong>: 
   <span class="simpara">
    Geçerli sınırlamalar nedeniyle, bir nesnenin yıkıcısında fiberler arasında
    seçim yapmak mümkün değildir.
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>Örnek 1 - Temel kullanım örneği</strong></p>
   <div class="example-contents">
    <div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Fiberi devam ettirmekte kullanılan değer: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br />echo </span><span style="color: #DD0000">"Fiber askıya alındığındaki değer: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>
Yukarıdaki örneğin çıktısı:</p></div>
   <div class="example-contents screen">
    <div class="cdata"><pre>
Fiber askıya alınırken kullanılan değer: fiber
Fiberi devam ettirmekte kullanılan değer: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>